# Class ContentPackageDescriptor

java.lang.Object
org.apache.sling.feature.scanner.Descriptor
org.apache.sling.feature.scanner.ArtifactDescriptor
org.apache.sling.feature.scanner.ContentPackageDescriptor

public abstract class ContentPackageDescriptor extends ArtifactDescriptor
Information about a content package.

Since:
  2.3.0

## Constructor Summary

Constructors
Constructor
Description
`ContentPackageDescriptor(String name)`
Constructor for the descriptor

## Method Summary

Modifier and Type
Method
Description
`abstract List<BundleDescriptor>`
`getBundles()`
Get the included bundles
`abstract List<org.apache.sling.feature.Configuration>`
`getConfigurations()`
Get the included configurations
`abstract List<String>`
`getContentPaths()`
Get the content paths
`abstract Properties`
`getPackageProperties()`
Get the package properties
`abstract ContentPackageDescriptor`
`getParentContentPackage()`
Get the parent content package
`abstract String`
`getParentContentPath()`
Get the parent content path
`boolean`
`hasEmbeddedArtifacts()`
Check whether the package has embedded artifacts
`boolean`
`isEmbeddedInContentPackage()`
Whether this artifact is embedded in a content package
`String`
`toString()`

### Methods inherited from class ArtifactDescriptor

`getArtifact, getArtifactFile, getManifest`

### Methods inherited from class Descriptor

`aggregate, checkLocked, getCapabilities, getCapabilities, getDynamicImportedPackages, getExportedPackages, getExportedPackages, getImportedPackages, getName, getRequirements, isLocked, lock`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ContentPackageDescriptor

public ContentPackageDescriptor(String name)
Constructor for the descriptor

Parameters:
  `name` - The name
Throws:
  `IllegalArgumentException` - if name is `null`

## Method Details

### getContentPaths

public abstract List<String> getContentPaths()
Get the content paths

Returns:
  The list of content paths

### getBundles

public abstract List<BundleDescriptor> getBundles()
Get the included bundles

Returns:
  The list of bundles, might be empty

### getConfigurations

public abstract List<org.apache.sling.feature.Configuration> getConfigurations()
Get the included configurations

Returns:
  The list of configurations, might be empty

### getParentContentPackage

public abstract ContentPackageDescriptor getParentContentPackage()
Get the parent content package

Returns:
  The parent content package or `null`

### getParentContentPath

public abstract String getParentContentPath()
Get the parent content path

Returns:
  The parent content path or `null`

### isEmbeddedInContentPackage

public boolean isEmbeddedInContentPackage()
Whether this artifact is embedded in a content package

Returns:
  `true` if embedded.

### hasEmbeddedArtifacts

public boolean hasEmbeddedArtifacts()
Check whether the package has embedded artifacts

Returns:
  `true` if the package has embedded artifacts

### getPackageProperties

public abstract Properties getPackageProperties()
Get the package properties

Returns:
  The package properties

### toString

public String toString()

Overrides:
  `toString` in class `Descriptor`